VERSION 2.00
Begin Form VBSYXSEN 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VB SYSEX GS Reset"
   ClientHeight    =   750
   ClientLeft      =   6000
   ClientTop       =   6195
   ClientWidth     =   2865
   Height          =   1155
   Icon            =   VBSYXSEN.FRX:0000
   Left            =   5940
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   750
   ScaleWidth      =   2865
   Top             =   5850
   Width           =   2985
   Begin MIDI Midi1 
      BuildNum        =   7
      Height          =   420
      InDevCount      =   2
      InDevice        =   0
      InDevNames      =   "Voyetra Super Sapi FM Driver|MPU-401 In"
      Left            =   0
      OutDevCount     =   2
      OutDevice       =   0
      OutDevNames     =   "Voyetra Super Sapi FM Driver|MPU-401 Out"
      Output          =   ""
      Top             =   0
      Width           =   420
   End
   Begin CommandButton ButtonPort 
      Caption         =   "Output Port"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin CommandButton ButtonSYSEX 
      Caption         =   "Send Sysex"
      Default         =   -1  'True
      Height          =   495
      Left            =   1440
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
End
Option Explicit
Declare Function midiOutGetNumDevs Lib "MMSYSTEM" () As Integer
Declare Function midiOutGetDevCaps Lib "MMSYSTEM" (ByVal wDeviceID As Integer, lpCaps As MIDIOUTCAPS, ByVal uSize As Integer) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFilename As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFileName As String) As Integer
Const INI_FILENAME = "VBSYX.INI"
Const APP_NAME = "Visual Basic SYSEX Decode Program"
' Const Version = "1.3i"
Dim outport As String

Sub ButtonPort_Click ()
    Dim nRetcode As Integer

    VBSYXMID.Show 1
    If portflag = 0 Then Exit Sub
    outport = VBSYXMID.List1.List(Val(VBSYXMID.Text.Text))
    nRetcode = WritePrivateProfileString(APP_NAME, "Output", outport, INI_FILENAME)
End Sub

Sub ButtonSYSEX_Click ()
    SYXSend
End Sub

Sub Form_Load ()
    Dim zz As Integer, flag As Integer
    Dim OutCaps As MIDIOUTCAPS
    Dim sDevName As String, nRetcode As Integer
    sDevName = Space(32)

    ' VBSYXSEN.Top = (screen.Height) - (Height * 4 / 3)
    ' VBSYXSEN.Left = (screen.Width / 2) - (Width / 2)
    nRetcode = GetPrivateProfileString(APP_NAME, "Output", "UserChoice", sDevName, 32, INI_FILENAME)
    outport = szTrim(sDevName)
    'If outport = "0" Then
    '    outport = "User must decide"
    'End If
    flag = 0
    Midi1.OutDevCount = midiOutGetNumDevs()
    VBSYXMID.List1.List(0) = "Device not enabled"
    For zz = 0 To Midi1.OutDevCount - 1            ' Midi Mapper = -1
        vntRet = midiOutGetDevCaps(zz, OutCaps, Len(OutCaps))
        If vntRet <> 0 Then
            MsgBox "midiOutGetDevCaps Error: " & vntRet
            Exit For
        End If
        VBSYXMID.List1.List(zz + 1) = OutCaps.szPname
        If outport = Mid$(OutCaps.szPname, 1, Len(outport)) Then flag = zz + 1
    Next zz
    If flag > 0 Then
        VBSYXMID.Text.Text = Str$(flag)
        VBSYXMID.List1.ListIndex = flag
        VBSYXMID.Cancel.Enabled = True
    Else
        ButtonPort_Click
    End If
    OpenSYX
End Sub

Sub Form_Unload (Cancel As Integer)
    End
End Sub

Sub OpenSYX ()
    Dim SYX As String * 210, Fname As String, crlf As String
    Dim Fnum As Integer, syxlen As Integer

    crlf = Chr$(10) + Chr$(13)
    Fname = App.Path + "\gsreset.syx"
    Fnum = FreeFile ' Determine file number.
    Open Fname For Binary Access Read As Fnum   ' Open file.
    syxlen = LOF(Fnum) ' Get number of bytes in file
    If syxlen = 0 Then
        syxlen = MsgBox(App.Path + "\GSRESET.SYX not found." + crlf$ + crlf$ + "Please copy the file to the correct directory.", 16, "File not found!")
        End
    End If
    If syxlen > 200 Then
        syxlen = MsgBox("Sorry, GSRESET.SYX is larger than 200 bytes in length!", 16, "File too large!")
        End
    End If
    Get Fnum, 1, SYX ' read as many bytes as we can into syx string
    Close   ' Close all Files
    outSYX = Left$(SYX, syxlen)
End Sub

Sub SYXSend ()
    Midi1.OutDevice = Val(VBSYXMID.Text.Text) ' MIDI Open
    If Midi1.OutDevice = 0 Then Exit Sub
    ' This works OK
    Midi1.Output = outSYX ' output SYSEX
    Midi1.OutDevice = 0   ' MIDI Close
End Sub

Function szTrim (szString As String) As String
    Dim pos As Integer, ln As Integer

    pos = InStr(szString, Chr$(0))
    ln = Len(szString)
    Select Case pos
        Case Is > 1
            szTrim = Trim(Left(szString, pos - 1))
        Case 1
            szTrim = ""
        Case Else
            szTrim = Trim(szString)
    End Select
End Function

