' Option Explicit
' MIDI output device capabilities structure
Type MidiOutCaps
    wMid As Integer                ' Manufacturer ID
    wPid As Integer                ' Product ID
    vDriverVersion As Integer      ' Driver version
    szPname As String * 32         ' Product name (NULL terminated string)
    wTechnology As Integer         ' Device type
    wVoices As Integer             ' n. of voices (internal synth only)
    wNotes As Integer              ' max n. of notes (internal synth only)
    wChannelMask As Integer        ' n. of Midi channels (internal synth only)
    dwSupport As Long              ' Supported extra controllers (volume, etc)
End Type
' MIDI data block header
Type MIDIHDR
    lpData As String             '  pointer to locked data block - this line is WRONG
    dwBufferLength As Long       '  length of data in data block
    dwBytesRecorded As Long      '  used for input only
    dwUser As Long               '  for client's use
    dwFlags As Long              '  assorted flags (see defines)
    midihdr_tag As Long          '  reserved for driver
    reserved As Long             '  reserved for driver
End Type
'return value from API Functions, handles etc
Global vntRet As Variant
Global portflag As Integer
Global outSYX

